/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomValue;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;


/**
* This item class contains the methods to set, get and validate the attribute present in Verifying Observer Sequence.
 */
public class VerifyingObserverSequenceItem extends Item  
{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 */
	VerifyingObserverSequenceItem()
	{
		super();
	}

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	VerifyingObserverSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates Verifying Observer Sequence Item with specified TransferSyntax and
	 * specified DictionaryReader
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	VerifyingObserverSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/**
	 * Sets The person authorized by the Verifying Organization (0040,A027) to verify documents of this type and who accepts 
	 * responsibility for the content of this document
	 * @param strVerifyingObserverName String value of Verifying Observer Name
	 */
	public void setVerifyingObserverName(String strVerifyingObserverName)
	{
		/* Accept the Verifying Observer Name of type PN.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0040,0xA075,strVerifyingObserverName,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0040,0xA075,DicomConstants.DCM_DT_PN, strVerifyingObserverName);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves Verifying Observer Name.
	 * @return String - value of Verifying Observer Name.
	 */
	public String getVerifyingObserverName()
	{
		Object objValue = getValue(0x0040,0xA075);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

	/**
	 * Retrieves pre-initialized object of Verifying Observer Identification Code Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence
	 * @return VerifyingObserverIdentificationCodeSequence - instance of Verifying Observer Identification Code Sequence
	 */
	public VerifyingObserverIdentificationCodeSequence getVerifyingObserverIdentificationCodeSequence()
	{
		VerifyingObserverIdentificationCodeSequence objVerifyingObserverIdentificationCodeSequence = null;
		IDataElement objIDataElement =  getDataForTag(0x0040,0xA088);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objVerifyingObserverIdentificationCodeSequence = (VerifyingObserverIdentificationCodeSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objVerifyingObserverIdentificationCodeSequence = (VerifyingObserverIdentificationCodeSequence)objDicomV3Factory.createSequence(0x0040,0xA088, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0040,0xA088, objVerifyingObserverIdentificationCodeSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0040,0xA088, DicomConstants.DCM_DT_SQ, objVerifyingObserverIdentificationCodeSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objVerifyingObserverIdentificationCodeSequence;
	}

	/**
	 * Sets Organization to which the Verifying Observer Name (0040,A075) is accountable for this document in the current interpretation procedure
	 * @param strVerifyingOrganization String value of Verifying Organization
	 */
	public void setVerifyingOrganization(String strVerifyingOrganization)
	{
		/* Accept the Verifying Organization of type LO.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0040,0xA027,strVerifyingOrganization,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0040,0xA027,DicomConstants.DCM_DT_LO, strVerifyingOrganization);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves Verifying Organization
	 * @return String - value of Verifying Organization
	 */
	public String getVerifyingOrganization()
	{
		Object objValue = getValue(0x0040,0xA027);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

	/**
	 * Sets Date and Time of verification by the Verifying Observer Name (0040,A075).
	 * @param strVerificationDateTime String value of Verification DateTime
	 */
	public void setVerificationDateTime(String strVerificationDateTime)
	{
		/* Accept the Verification DateTime of type DT.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0040,0xA030,strVerificationDateTime,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0040,0xA030,DicomConstants.DCM_DT_DT, strVerificationDateTime);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves Verification DateTime
	 * @return String - value of Verification DateTime
	 */
	public String getVerificationDateTime()
	{
		Object objValue = getValue(0x0040,0xA030);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

	/**
	 * Validates all the attributes in {@link VerifyingObserverSequenceItem} that are present in the DataSet.
	 * @return boolean - Success -true, Failure - false.
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{
		try{
			if(!contains(0x0040,0xA075))
				throw new MandatoryMissingException("0040,A075");
			if(!contains(0x0040,0xA088))
				throw new MandatoryMissingException("0040,A088");
			if(!contains(0x0040,0xA027))
				throw new MandatoryMissingException("0040,A027");
			if(!contains(0x0040,0xA030))
				throw new MandatoryMissingException("0040,A030");
		}
		catch(MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),me);
		}
		return true;
	}
}
